local image = love.graphics.newImage("Sprites/sub.png")
local anim = require "anim8/anim8"
love.graphics.setDefaultFilter("nearest", "nearest")

local tilemap = {
    {1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
    {1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0}

}

local player = {
    x = 50,
    y = 50,
    w = 15,
    h = 9,
    img = nil,
}

player.phys = {}

player.phys.body = nil
player.phys.fixture = nil
player.phys.shape = nil

function love.load()
    love.window.setMode(640, 360)
    Map = tilemap
    world = love.physics.newWorld(0, 0.2*64, true)
    local walls = {}
    for i = 1, #Map do 
        for j = 1, #Map[i] do
            if Map[i][j] == 1 then
                local wall = {}
                --[[
                local a = 1
                local b = 1
                if i == 1 then a = 0 else a = i-2*16
                    --]]
                wall.body = love.physics.newBody(world,j*16,i*16)
                wall.shape = love.physics.newRectangleShape(16, 16)
                wall.fixture = love.physics.newFixture(wall.body, wall.shape)
                table.insert(walls, wall)
            end
        end
    end
    Player = player
    Player.img = image
    anim8 = anim

    local g = anim8.newGrid(16, 16, Player.img:getWidth(), Player.img:getHeight())
    animation = anim8.newAnimation(g("1-3",1), 0.1)

    Player.phys.body = love.physics.newBody(world, Player.x, Player.y,"dynamic")
    Player.phys.shape = love.physics.newRectangleShape(Player.w,Player.h)
    Player.phys.fixture = love.physics.newFixture(Player.phys.body, Player.phys.shape)

end

function love.update(dt)
    world:update(dt)
    move(dt)
    animation:update(dt)
end

function move(dt)
    if love.keyboard.isScancodeDown("d") then
        Player.phys.body:applyForce(50, 0)
    end

    if love.keyboard.isScancodeDown("a") then 
        Player.phys.body:applyForce(-50, 0)
    end

    if love.keyboard.isScancodeDown("w") then
        Player.phys.body:applyForce(0, -50)
    end

    if love.keyboard.isScancodeDown("s") then
        Player.phys.body:applyForce(0, 50)
    end
end

function love.draw()
    --world:draw()
    for i = 1, #Map do 
        for j = 1, #Map[i] do 
            if Map[i][j] == 1 then
                love.graphics.rectangle("fill",(j*16)*2,(i*16)*2,16*2,16*2)
            end
        end
    end

    love.graphics.push()
    love.graphics.scale(2,2)

    animation:draw(Player.img, Player.phys.body:getX(), Player.phys.body:getY())
    love.graphics.rectangle("line", Player.phys.body:getX() + 1, Player.phys.body:getY() + 3, Player.w, Player.h)

    love.graphics.pop() 
end

